#lang racket

(require db)

(define pgc-bench
  (postgresql-connect #:user "bench"
		      #:database "t1"
		      #:password "fNfwREMqO69TB9YqE+/OzF5/k+s="
		      #:port 5433))
(define pgc
  (postgresql-connect #:user "t1"
		      #:database "t1"
		      #:password "fNfwREMqO69TB9YqE+/OzF5/k+s="))

(define TIMES 3000)

;; TODO how to create a macro that allow cl dotimes?
;; (dotimes (i 10)
;;   (display (format "~a\n" i)))

;; run prog many times, show time cost.
(define-syntax-rule (timeit prog times)
  (let ((start (current-inexact-milliseconds)))
    (do ([n 0 (+ n 1)])
	((> n times))
      prog)
    (display (format "~as\n" (/ (- (current-inexact-milliseconds) start) 1000)))))

(define (select-test)
  (timeit (query-rows pgc "SELECT id, bar FROM foo") TIMES))

(define (update-test)
  (timeit (query-exec pgc "UPDATE foo SET bar=bar+1 WHERE id=1") TIMES))

(define (main)
  (select-test)
  (update-test))

(main)
